<!doctype html>
<html lang="es">
    <head>
        <meta charset="utf-8">

        <title>Taller sobre Tor</title>

        <meta name="description" content="Taller sobre Tor: ¿qué es?, ¿cómo se usa?, ¿para qué sirve? y mucho más">
        <meta name="author" content="Muchos colaboradores">

        <meta name="apple-mobile-web-app-capable" content="yes">
        <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

        <link rel="stylesheet" href="vendor/reveal.js/css/reveal.css">
        <link rel="stylesheet" href="vendor/reveal.js/css/theme/night.css" id="theme">

        <!-- Theme used for syntax highlighting of code -->
        <link rel="stylesheet" href="vendor/reveal.js/lib/css/zenburn.css">

        <!-- Printing and PDF exports -->
        <script>
            var link = document.createElement( 'link' );
            link.rel = 'stylesheet';
            link.type = 'text/css';
            link.href = window.location.search.match( /print-pdf/gi ) ? 'vendor/reveal.js/css/print/pdf.css' : 'vendor/reveal.js/css/print/paper.css';
            document.getElementsByTagName( 'head' )[0].appendChild( link );
        </script>
        <style>
            .reveal aside {
                font-size: 0.5em;
                font-style: italic;
                text-align: right;
            }
        </style>
        <!--[if lt IE 9]>
        <script src="vendor/reveal.js/lib/js/html5shiv.js"></script>
        <![endif]-->
    </head>

    <body>
        <!-- This work is licensed under the Creative Commons Attribution-ShareAlike 4.0 International License. To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/4.0/ or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA.-->
        <div class="reveal">
            <div class="slides">

                <!-- openning -->
                <section>
                    <section data-background="assets/imgs/tor-powering-digital-resistance.jpg">
                    </section>

                    <section data-background="assets/imgs/tor-roots.png">
                        <p>Ciclo de talleres sobre Tor en el marco del proyecto
                            <em>Enhancing privacy and anonymity in the Latin
                                American context</em> por Derechos Digitales y
                            Tor Project.</p>
                        <aside>Octubre 2018, CABA, Argentina</aside>
                        <aside>Abril 2019, CABA, Argentina</aside>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>¿Qué es la red Tor?</h1>
                        <p><a href="https://www.torproject.org/">The Onion Router</a>  (2002 - actualidad) es una red distribuida (de nodos) dentro de Internet; una red dentro de otra, digamos.</p>
                        <p>¿Solo eso?</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-ecosystem.png"></img>
                    </section>
                    <section>
                        <h2>Onion Router (pre Tor)</h2>
                        <p><a href="https://www.onion-router.net/">Onion Routing</a> (1995 - 2004) fue el programa de investigación del Laboratorio de Investigación Naval de los EE.UU., que lanzó la primera generación en 1996. El <a href="https://www.onion-router.net/Summary.html">objetivo</a> era resolver los problemas de <em>espionaje</em> y <em>análisis</em> de tráfico, y eliminar <em>información de identidad</em> para obtener comunicaciones privadas y anónimas.</p><!-- + funding from DARPA 1996 -->
                    </section>
                    <section>
                        <h2>¿Cuál es el objetivo?</h2>
                        <p><strong>Anonimato</strong> + <strong>Privacidad</strong></p>
                        <p>La idea de Tor es que un usuario no pueda ser rastreado: el usario puede navegar libremente.</p>
                    </section>
                    <section>
                        <h2>¿Cómo se financia?</h2>
                        <ul>
                            <li>Omidyar Network</li>
                            <li>International Broadcasting Bureau</li>
                            <li>Bell Security Solutions</li>
                            <li>Electronic Frontier Foundation</li>
                            <li>varias agencias del gobierno (!) y grupos de investigación</li>
                            <li>muchos contribuidores privados</li>
                        </ul>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>Anonimato y privacidad</h1>
                    </section>
                    <section>
                        <p>ONG <a href="https://twitter.com/derechosdigital">Derechos Digitales</a>, campaña <a href="https://twitter.com/hashtag/defendamoselanonimato">#DefendamosElAnonimato</a>.</p>
                        <video controls="" muted="" poster="assets/imgs/defendamos_anonimato.png">
                            <source src="assets/vids/vid_anonimato.webm" type="video/webm">
                            Tu navegador no soporta el sistema de video.
                        </video>
                    </section>
                    <section>
                        <p><strong>¿Para qué esconderme si no tengo nada que ocultar?</strong><br />
                        =<br />
                        <strong>¿Para qué quiero libertad de expresión si no tengo nada que decir?</strong></p>
                    </section>
                    <section>
                        <h2>La privacidad es un derecho</h2>
                    </section>
                    <section>
                        <blockquote cite="https://es.wikipedia.org/wiki/Privacidad#Declaraciones_Universales">Nadie será objeto de injerencias arbitrarias en su vida privada, su familia, su domicilio o su correspondencia, ni de ataques a su honra o a su reputación. Toda persona tiene derecho a la protección de la ley contra tales injerencias o ataques.</blockquote>
                        <aside>Declaración Universal de los Derechos Humanos, Artículo 12</aside>
                    </section>
                    <section>
                        <blockquote cite="https://es.wikipedia.org/wiki/Privacidad#Declaraciones_Universales"><ol>
                        <li>Nadie será objeto de injerencias arbitrarias o ilegales en su vida privada, su familia, su domicilio o su correspondencia, ni de ataques ilegales a su honra y reputación.</li>
                        <li>Toda persona tiene derecho a la protección de la ley contra esas injerencias o esos ataques.</li>
                        </ol></blockquote>
                        <aside>Pacto Internacional de Derechos Civiles y Políticos, Artículo 17</aside>
                    </section>
                    <section>
                        <blockquote cite="https://es.wikipedia.org/wiki/Privacidad#Legislaci.C3.B3n_nacional_en_los_pa.C3.ADses_americanos">
                        Art. 18. El domicilio es inviolable, como también la correspondencia epistolar y los papeles privados [...].<br />
                        Art. 19. Las acciones privadas [...] que de ningún modo ofendan al orden y a la moral pública, ni perjudiquen a un tercero, están solo reservadas a Dios (!), y exentas de la autoridad de los magistrados.
                        </blockquote>
                        <aside>Constitución de la Nación Argentina</aside>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>¿Para qué?</h1>
                    </section>
                    <section>
                        <p>Cualquiera que quiera <strong>ser anónimo</strong> en internet. Por ejemplo <strong>periodistas</strong>, personas que por algún motivo sean <strong>perseguidas políticamente</strong>, como opositores a regímenes autocráticos o dictaduras, programadores y desarrolladores, <strong>hackers</strong> (en su verdadero significado), las fuerzas de la ley y, también, <strong>criminales</strong>.</p>
                    </section>
                    <section>
                        <h3>República Árabe Siria - 2013</h3>
                        <blockquote cite="http://resources.infosecinstitute.com/project-artemis-osint-activities-on-deep-web/">cruento control sobre el rastreo en internet a activistas; los están torturando.</blockquote>
                        <img src="assets/imgs/tormetrics-syria-2012-2013.png" alt="Tor metrics Syria"></img>
                    </section>
                    <section>
                        <h3>Turquía - 2013</h3>
                        <blockquote cite="http://resources.infosecinstitute.com/project-artemis-osint-activities-on-deep-web/">revueltas populares contra el primer ministro Erdogan. Pico en Junio de 2013 durante las manifestaciones.</blockquote>
                        <img src="assets/imgs/tormetrics-turkey-2012-2013.png" alt="Tor metrics Turkey"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/Geographies_of_Tor.png" alt="Tor usage worldwide per country"></img>
                        <p><small>2014. By Stefano.desabbata (Own work) CC BY-SA 4.0, via <a href="https://commons.wikimedia.org/wiki/File%3AGeographies_of_Tor.png">Wikimedia Commons</a>.</small></p>
                    </section>
                    <section>
                        <h3> Argentina - 2011/2019</h3>
                        <img src="assets/imgs/userstats-relay-country-ar-2011-01-01-2019-04-10-points.png"></img>
                    </section>
                    <section>
                        <h3>Argentina - 2016</h3>
                        <img src="assets/imgs/ambito-2016-tuiteros-detenidos.png"></img>
                    </section>
                    <section>
                        <h3>Argentina - 2017</h3>
                        <img src="assets/imgs/diariosur-2017-persecucion-tuiteros.png"></img>
                    </section>
                    <section>
                        <h3>Argentina - 2018</h3>
                        <img src="assets/imgs/elesquiu-2018-detenienen-tuitero.png"></img>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>¿Antro de contenido ilícito?</h1>
                    </section>
                    <section>
                        <blockquote>El <em>National Center for Missing & Exploited Children</em> analiza <strong>25 millones</strong> de imágenes anualmente (alrededor de 480 mil por semana).*</blockquote>
                        <aside>* Thorn</aside>
                        <p>¿De dónde salen? ¿Cómo se accede a ellas? ¿Son Tor u otras herramientas, o el anonimato, los culpables?</p>
                    </section>
                    <section>
                        <p>El Departamento de Justicia de los EE.UU. dijo que el 80% del tráfico de Tor es PI.</p>
                        <p>El Proyecto Tor dice que cuanto mucho el 1% del tráfico lo es, y que de los servicios ocultos, menos del 2% son dedicados a PI.</p>
                        <aside>2015, Wired</aside>
                    </section>
                    <section>
                        <img src="assets/imgs/hidserv-rend-relayed-cells-2010-12-01-2018-10-13.png"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/bandwidth-2010-12-01-2018-10-13.png"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/internet-live-stats.png"></img>
                        <p><strong>1.5Gb/s</strong> vs <strong>140Gb/s</strong> vs <strong>63000Gb/s</strong></p>
                    </section>
                    <section>
                        <img src="assets/imgs/internet-statistics.png"></img>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>¿Cómo funciona?</h1>
                    </section>
                    <section>
                        <h2>El enrutamiento cebolla</h2>
                        <img src="assets/imgs/how_tor_works_full.png" alt="How Tor works"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/how_tor_works1.png" alt="How Tor works detail 1"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/how_tor_works2.png" alt="How Tor works detail 2"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/how_tor_works3.png" alt="How Tor works detail 3"></img>
                    </section>
                    <section>
                        <img style="background-color: white; width: 75%;" src="assets/imgs/onion_diagram.svg" alt="Tor layers"></img>
                        <p style="text-align: right"><a href="https://en.m.wikipedia.org/wiki/File:Onion_diagram.svg">SVG Diagram of the "Onion Routing" Principle</a> - by  Harrison Neal <em>HANtwister</em> - CC BY-SA 3.0</p>
                    </section>
                    <section>
                        <h2>Los nodos de la red</h2>
                        <ul>
                            <li>Creados y administrados por voluntarios, empresas, grupos.</li>
                            <li>Tres tipos: de entrada, intercambio y salida.</li>
                            <li>Algunos maliciosos.</li>
                        </ul>
                    </section>
                    <section>
                        <h3>¿Cómo ser nodo?</h3>
                        <ul>
                            <li>Muy sencillo, la web del proyecto tiene guías detalladas.</li>
                            <li>Se puede serlo de cualquier tipo.</li>
                            <li><strong>¡Cuidado al ser nodo de salida desde tu casa!</strong></li>
                            <li>Se puede donar dinero a ONG para poner nodos por uno: <a href="https://www.torservers.net/">Tor servers</a>, <a href="https://www.noisebridge.net/wiki/Noisebridge_Tor">Noisebridge</a>, <a href="https://nos-oignons.net/">Nos Oignons</a>, <a href="https://www.dfri.se/donera/?lang=en">DFRI</a>.
                        </ul>
                    </section>
                    <section>
                        <h3>Nodos de salida en Argentina</h3>
                        <img src="assets/imgs/arg-exit-relays.png"></img>
                        <p>¡Necesitamos más!</p>
                    </section>
                    <section>
                        <h3>Nodos de salida en Argentina</h3>
                        <img src="assets/imgs/arg-exit-relays-20190410.png"></img>
                        <p>Abril 2019: ¡Aún necesitamos más!</p>
                    </section>
                    <section>
                        <h2>Servicios "onion"</h2>
                        <p>Anteriormente: servicios ocultos</p>
                        <p>No existe "deep web", ni "dark net", ni otros nombres mediáticos</p>
                        <ul>
                            <li>Servidor web en un nodo: <em>hidden service</em>.</li>
                            <li>Accesibles <em>únicamente</em> a través de la red.</li>
                            <li>Emplean una dirección especial: <em>onion address</em>.</li>
                            <li>Solo un 3.4% del total de tráfico en Tor - hasta el 2015 - se realiza hacia servicios ocultos</li>
                    </section>
                    <section>
                        <p>¡Tor sigue en alpha! Última versión a día de hoy: 0.3.5.2-alpha</p>
                        <p>En el 2017 se introdujeron cambios fundamentales en lo que respecta a seguridad: se reemplazaron los algoritmos antiguos SHA1/DH/RSA1024 con los modernos SHA3/ed25519/curve25519</p>
                    </section>
                    <section>
                        <h2>Aplicaciones</h2>
                        <p>La forma más común de acceder a tor es mediante Tor Browser (para PC/MAC) u Orbot+OrFox en Android.</p>
                        <p>Para torificar programas, la manera más conveniente es usar Whonix Gateway.</p>
                        <p>Una forma simple para compartir archivos es usar OnionShare.</p>
                        <p>Para navegar anónimamente en forma fácil, puede usarse el sistema operativo Tails.</p>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>¿Quiénes me están mirando?</h1>
                    </section>
                    <section>
                        <img src="assets/imgs/eff_tor-http.png" alt="EFF Tor http"></img>
                    </section>
                    <section>
                        <img src="assets/imgs/eff_tor-https.png" alt="EFF Tor https"></img>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>Servicios "onion" en detalle</h1>
                    </section>
                    <section>
                        <h2>Direcciones .onion</h2>
                        <p>Interpretadas por el cliente, es la única forma de acceso al servicio (generalmente un sitio web).<p>
                        <p>Codificado en base32 de los primeros 80 bits del SHA-1 de la "identity key".<br />
                        Ejemplo: <small>kpanicfz4v7lrsrv.onion</small></a>
                        <p>La nueva versión 3 utiliza llaves ECC y la dirección es la llave pública completa en base32.<br />
                        Ejemplo: <small>4acth47i6kxnvkewtm6q7ib2s3ufpo5sqbsnzjpbi7utijcltosqemad.onion</small></p>
                    </section>
                    <section>
                        <h2>Protocolo</h2>
                        <p>Conexión en 6 pasos.</p>
                        <p>Se emplean nodos existentes como <em>nodos de introducción</em> y <em>puntos de encuentro</em>.</p>
                        <p>Existe una DB distribuida que contiene información de los servicios existentes.</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-onion-services-1.png"></img>
                        <p>Servicio: selecciona aleatoriamente los <em>nodos de introducción</em>.</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-onion-services-2.png"></img>
                        <p>Servicio: publica el <em>descriptor de servicio</em> en DB distribuida.</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-onion-services-3.png"></img>
                        <p>Cliente: obtiene el <em>descriptor de servicio</em> de DB distribuida y selecciona <em>punto de encuentro</em>.</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-onion-services-4.png"></img>
                        <p>Cliente: envía a un <em>nodo de introducción</em> paquete cifrado con info de <em>punto de encuentro</em> para el Servicio.</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-onion-services-5.png"></img>
                        <p>Servicio: se conecta con <em>punto de encuentro</em> (deberá mantener listado fijo de nodos de entrada).</p>
                    </section>
                    <section>
                        <img src="assets/imgs/tor-onion-services-6.png"></img>
                        <p>Punto de encuentro: notifica al Cliente y hace de intermediario.</p>
                    </section>
                </section>

                <section>
                    <section>
                        <h1>Nodos y enrutado en detalle</h1>
                    </section>
                    <section>
                        <h2>Nodos</h2>
                        <p>Autenticados con <em>onion key</em>, rota cada semana. Tor siempre valida la autenticidad de cada nodo con la "onion key", evitando que el nodo de entrada falsifique la ruta.</p>
                        <p>Cada nodo tiene asimismo una "identity key", que es de larga duración. Estas se comparten en el directorio de nodos, y son firmadas por las autoridades de directorio (lista fijada en el cliente por Tor Project).</p>
                    </section>
                    <section>
                        <h3>Entrada o guardián</h3>
                        <p>Si un atacante controla ambos extremos de la comunicación, todo está perdido.<br />
                        Supongamos que puede ver <code>C</code> de <code>N</code> nodos, entonces puede correlacionar con probabilidad <code>(c/n)^2</code>. El usuario no puede escapar de este perfilado.<p>
                        <p>Solución: nodos confiables como entrada, son unos pocos y elegidos al azar. Da chance al usuario de escapar del perfilado en <code>(n-c)/n</code>.</p>
                    </section>
                    <section>
                        <h2>Enrutado</h2>
                        <p>Comunicación en paquetes de 512B llamados "celdas". Conexiones siempre con TLS + cifrado para cada nodo con llaves efímeras.</p>
                        <p>El cliente forma circuito de manera aleatoria. Pueden incluirse/excluirse nodos (por huella o por país) mediante configuración, pero <em>no se recomienda hacerlo</em>.</p>
                        <p>¿Por qué 3 saltos?: compromiso entre <em>seguridad</em> y eficiencia. Planeado: aleatoria de cantidad cuando la red sea más estable y eficiente.</p>
                    </section>
                    <section>
                        <h3>Circuito</h3>
                        <img src="assets/imgs/tor-circuit-2hop.png"></img>
                        <p>El cliente arma el circuito y dirige la orquestación.</p>
                        <aside>Ejemplo con solo 2 saltos</aside>
                    </section>
                    <section>
                        <p>Primero se establece con el nodo de entrada, luego mediante el mismo se alcanza el intermediario y finalmente el de salida.</p>
                        <p>Renovación de circuitos cada 10', excepto conexiones <em>long-lived</em> o streams (reduce las chances de que un atacante con alcance parcial sobre la red encuentre el origen de la conexión).</p>
                    </section>
                    <section>
                        <h4>¿Y si le agrego una VPN?</h4>
                        <p>Se puede agregar una VPN como conexión inicial: debemos confiar en el proveedor dado que éste sabrá nuestra IP y que estamos usando Tor.<br />
                        Se puede agregar una VPN como conexión final: usando trucos de enrutado, es posible incrustar toda la comunicación a través de una VPN; la misma sabrá nuestra IP y a dónde nos estamos conectando (bypass Tor).</p>
                        <p>Se recomienda <strong>no usar VPN</strong>. La alternativa es tener un servidor privado como puente.</p>
                    </section>
                </section>

                <!-- ending -->
                <section>
                    <section>
                        <h1>Fuentes</h1>
                    </section>
                    <section>
                        <ul>
                            <li><a href="https://www.torproject.org/about/overview.html.en">Tor: Overview - Tor Project</a></li>
                            <li><a href="https://www.onion-router.net/">Onion Router</a> (initial project)</li>
                            <li><a href="https://www.torproject.org/about/sponsors.html.en">Tor: Sponsors</a></li>
                            <li><a href="https://es.wikipedia.org/wiki/Privacidad">Privacidad - Wikipedia</a></li>
                            <li><a href="http://resources.infosecinstitute.com/project-artemis-osint-activities-on-deep-web/">Project Artemis – OSINT activities on Deep Web</a></li>
                            <li><a href="https://www.washingtonpost.com/news/the-switch/wp/2013/08/29/its-a-mystery-why-is-tor-usage-doubling-all-of-a-sudden/">It’s a mystery: Why is Tor usage doubling all of a sudden? - The Washington Post</a></li>
                            <li><a href="https://metrics.torproject.org/userstats-relay-country.html?start=2011-01-01&end=2018-10-13&country=ar&events=points">Tor: Metrics - Directly connecting users from Argentina</a></li>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li><a href="http://www.ambito.com/849107-detuvieron-a-dos-tuiteros-por-amenazas-contra-macri">Detuvieron a dos tuiteros por amenazas contra Macri</a></li>
                            <li><a href="https://www.diariosur.es/internacional/america-latina/persecucion-tuiteros-20171105000652-ntvo.html">Persecución a tuiteros</a></li>
                            <li><a href="https://www.elesquiu.com/nacionales/2018/10/11/detienen-un-joven-que-amenazo-con-bajar-con-un-fusil-macri-301683.html">Detienen a un joven que amenazó con "bajar" con un fusil a Macri</a></li>
                            <li><a href="https://www.wearethorn.org/child-pornography-and-abuse-statistics/">Thorn</a></li>
                            <li><a href="https://www.wired.com/2015/01/department-justice-80-percent-tor-traffic-child-porn/">No, Department of Justice, 80 Percent of Tor Traffic Is Not Child Porn</a></li>
                            <li><a href="https://metrics.torproject.org/bandwidth.html?start=2011-0-01&end=2018-10-13">Tor: Metrics - Total relay bandwidth</a></li>
                            <li><a href="https://metrics.torproject.org/hidserv-rend-relayed-cells.html?start=2010-12-01&end=2018-10-13">Tor: Metrics - Onion-service traffic</a></li>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li><a href="http://www.internetlivestats.com/one-second/#traffic-band">Internet Live Stats - 1 second</a></li>
                            <li><a href="https://www.guardchild.com/statistics/">Internet Statistics</a></li>
                            <li><a href="https://www.maketecheasier.com/mte-explains-onion-routing/">MTE Explains: What is Onion Routing (OR/TOR) And How You Can Get Your Privacy Back - Make Tech Easier</a></li>
                            <li><a href="https://blog.torproject.org/blog/some-statistics-about-onions">Some statistics about onions - Tor Project</a></li>
                            <li><a href="http://www.extremetech.com/internet/226106-onionscan-tests-dark-web-sites-to-see-if-they-really-are-anonymous">OnionScan tests ‘dark web’ sites to see if they really are anonymous - ExtremeTech</a></li>
                            <li><a href="https://tor.derechosdigitales.org/torificate/p3.1.2/">Derechos Digitales - Torifícate</a></li>
                            <li><a href="https://metrics.torproject.org/rs.html#search/flag:exit%20country:ar%20">Tor: Relay Search - Exit nodes in Argentina</a></li>
                        </ul>
                    </section>
                    <section>
                        <ul>
                            <li><a href="https://www.eff.org/pages/tor-and-https">Tor and HTTPS - EFF</a></li>
                            <li><a href="https://svn.torproject.org/svn/projects/design-paper/tor-design.html">Tor: The Second-Generation Onion Router</a></li>
                            <li><a href="https://www.torproject.org/docs/onion-services.html.en">Tor: Onion Service Protocol</a></li>
                            <li><a href="https://gitweb.torproject.org/torspec.git/tree/">Tor's protocol specifications GIT</a></li>
                        </ul>
                    </section>
                </section>
                <section>
                    <h1>Hack the planet!</h1>
                    <p>git.rlab.be/tor<br/>
                    ivan.barreraoro.com.ar/presentation/talleres-tor</p>
                    <p style="text-align: right;"><br />Licencia <strong>CC BY-SA 4.0</strong></p>
                </section>

            </div>
        </div>

        <script src="vendor/reveal.js/lib/js/head.min.js"></script>
        <script src="vendor/reveal.js/js/reveal.js"></script>

        <script>

            // More info https://github.com/hakimel/reveal.js#configuration
            Reveal.initialize({
                controls: true,
                progress: true,
                history: true,
                center: true,

                transition: 'slide', // none/fade/slide/convex/concave/zoom

                // More info https://github.com/hakimel/reveal.js#dependencies
                dependencies: [
                    { src: 'vendor/reveal.js/lib/js/classList.js', condition: function() { return !document.body.classList; } },
                    //{ src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
                    //{ src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
                    { src: 'vendor/reveal.js/plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
                    //{ src: 'plugin/search/search.js', async: true },
                    //{ src: 'plugin/zoom-js/zoom.js', async: true },
                    //{ src: 'plugin/notes/notes.js', async: true }
                ]
            });

        </script>

    </body>
</html>
